'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_Component) {
    _inherits(Button, _Component);

    function Button(props) {
        _classCallCheck(this, Button);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Button).call(this, props));

        _this._onClick = _this._onClick.bind(_this);

        _this.state = {
            disabled: _this.props.disabled
        };
        return _this;
    }

    _createClass(Button, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (this.state.disabled !== prevState.disabled) {
                this.props.changeCallback();
            }
        }
    }, {
        key: '_onClick',
        value: function _onClick(e) {
            if (!this.state.disabled) {
                this.props.clickCallback();
            }
        }
    }, {
        key: 'getClassName',
        value: function getClassName(classes) {
            return classes && classes.length ? classes.join(' ') : '';
        }
    }, {
        key: 'disabled',
        value: function disabled(v) {
            if (typeof v === 'undefined') {
                return this.state.disabled;
            } else {
                this.setState({
                    disabled: v
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var type = this.props.type ? 'btn-' + this.props.type : 'btn';
            var classes = this.props.classes;
            classes.push(type);
            if (this.state.disabled) {
                classes.push('disabled');
            }
            var className = this.getClassName(classes);
            return _react2.default.createElement(
                'a',
                { className: className, onClick: this._onClick },
                this.props.children
            );
        }
    }]);

    return Button;
}(_react.Component);

exports.default = Button;


Button.types = ['', 'flat', 'floating', 'large'];

Button.propTypes = {
    type: _react.PropTypes.oneOf(Button.types),
    disabled: _react.PropTypes.bool,
    classes: _react.PropTypes.array,
    changeCallback: _react.PropTypes.func,
    clickCallback: _react.PropTypes.func
};

Button.defaultProps = {
    type: '',
    disabled: false,
    classes: [],
    changeCallback: function changeCallback() {},
    clickCallback: function clickCallback() {}
};